package ru.alphatech.icfpc.cards;

import ru.alphatech.icfpc.game.ICFPCException;
import ru.alphatech.icfpc.game.IValue;
import ru.alphatech.icfpc.game.Player;
import ru.alphatech.icfpc.game.Value;

public class Succ extends AbstractCard
{
	@Override
	public String getName() {
		return "succ";
	}
	
	@Override
	public IValue returnValue(IValue nobj, Player proponent, Player opponent)
	{
		incAndTest();
		
		if(nobj instanceof Value)
		{
			int n = ((Value)nobj).getValue();

			if (n == 65535)
			{
				return new Value(65535);
			}
			else
			{
				return new Value(n + 1);
			}
		}
		else
		{
			throw new ICFPCException();
		}
	}
}
