package ru.alphatech.icfpc.game.strategy;

import java.io.PrintStream;
import java.util.LinkedList;
import java.util.List;
import java.util.Queue;

import ru.alphatech.icfpc.game.Batch;
import ru.alphatech.icfpc.game.Player;

public class OtherStrategy implements IStrategy {
	
	private static Queue<Batch> batches = new LinkedList<Batch>();
	
	public void clearBatcher(){
		batches.removeAll(batches);
	}
	
	public void addBatcher(List<Batch> batches){
		this.batches.addAll(batches);
	}
	
	@Override
	public Batch move(Player proponent, Player opponent) {
		return batches.poll();
	}

}
